import { ModuleWithProviders, NgModule, NO_ERRORS_SCHEMA } from "@angular/core";
import { FormsModule } from "@angular/forms";
import { XdceArchModule } from "@isp/xdce-arch-core";
import { NbpModule } from "@isp/xdce-widget";
import { NgbModule } from "@ng-bootstrap/ng-bootstrap";
import {
  AgGridModule,
  AngularFrameworkComponentWrapper,
  AngularFrameworkOverrides,
} from "ag-grid-angular";
import { NbpBreadCrumbsComponent } from "./widgetfideuram/components/nbp-bread-crumbs/nbp-bread-crumbs.component";
import { NbpFidBarChartComponent } from "./widgetfideuram/components/nbp-fid-bar-chart/nbp-fid-bar-chart.component";
import { NbpFidButtonBarComponent } from "./widgetfideuram/components/nbp-fid-button-bar/nbp-fid-button-bar.component";
import { FidRplCalendarNOA11Y } from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap-noa11y/datepicker/datepicker";
import { NgbFidInputDatepickerNOA11Y } from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap-noa11y/datepicker/datepicker-input";
import { NgbFidDatepickerRoutingViewNOA11Y } from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap-noa11y/datepicker/datepicker-routing-view";
import { FidRplCalendar } from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap/datepicker/datepicker";
import { NgbFidInputDatepicker } from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap/datepicker/datepicker-input";
import { NgbFidDatepickerRoutingView } from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap/datepicker/datepicker-routing-view";
import { NbpCalendarGenericComponentA11Y } from "./widgetfideuram/components/nbp-fid-calendar-generic/nbp-calendar-generic.component.a11y";
import { NbpCalendarGenericComponentNOA11Y } from "./widgetfideuram/components/nbp-fid-calendar-generic/nbp-calendar-generic.component.noa11y";
import { NbpFidCalendarGeneric } from "./widgetfideuram/components/nbp-fid-calendar-generic/nbp-fid-calendar-generic.component";
import { NbpFidComboComponent } from "./widgetfideuram/components/nbp-fid-combo/nbp-fid-combo.component";
import { NbpFidDonutChartComponent } from "./widgetfideuram/components/nbp-fid-donut-chart/nbp-fid-donut-chart.component";
import { NbpFidPyramidChartComponent } from "./widgetfideuram/components/nbp-fid-pyramid-chart/nbp-fid-pyramid-chart.component";
import { NbpFidSidePopupComponent } from "./widgetfideuram/components/nbp-fid-side-popup/nbp-fid-side-popup.component";
import { NbpFidTableComponent } from "./widgetfideuram/components/nbp-fid-table/nbp-fid-table.component";
import { NbpFidToggleTabComponent } from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tab.component";
import { NbpFidToggleTabComponentA11Y } from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tab.component.a11y";
import { NbpFidToggleTabComponentNOA11Y } from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tab.component.noa11y";
import { NbpFidToggleTabsetComponent } from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tabset.component";
import { NbpFidToggleTabsetComponentA11Y } from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tabset.component.a11y";
import { NbpFidToggleTabsetComponentNOA11Y } from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tabset.component.noa11y";
import { ShowcaseComponent } from "./widgetfideuram/components/showcase/showcase.component";
import { Showcase1Component } from "./widgetfideuram/components/showcase/showcase1.component";
import { WidgetFideuramShowcaseComponent } from "./widgetfideuram/components/widget-fideuram-showcase/widget-fideuram-showcase.component";
import { NgbDatepickerService, NgbDatepickerServiceNOA11Y } from '@isp/xdce-widget';

export { AgGridModule } from "ag-grid-angular";
export * from "./widgetfideuram/components/nbp-bread-crumbs/nbp-bread-crumbs.component";
export * from "./widgetfideuram/components/nbp-fid-bar-chart/nbp-fid-bar-chart.component";
export * from "./widgetfideuram/components/nbp-fid-button-bar/nbp-fid-button-bar.component";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap-noa11y/datepicker/datepicker";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap-noa11y/datepicker/datepicker-input";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap/datepicker/datepicker";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/@ng-bootstrap/datepicker/datepicker-input";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/nbp-calendar-generic.component.a11y";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/nbp-calendar-generic.component.noa11y";
export * from "./widgetfideuram/components/nbp-fid-calendar-generic/nbp-fid-calendar-generic.component";
export * from "./widgetfideuram/components/nbp-fid-combo/nbp-fid-combo.component";
export * from "./widgetfideuram/components/nbp-fid-donut-chart/nbp-fid-donut-chart.component";
export * from "./widgetfideuram/components/nbp-fid-pyramid-chart/nbp-fid-pyramid-chart.component";
export * from "./widgetfideuram/components/nbp-fid-side-popup/nbp-fid-side-popup.component";
export * from "./widgetfideuram/components/nbp-fid-table/nbp-fid-table.component";
export * from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tab.component";
export * from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tab.component.a11y";
export * from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tab.component.noa11y";
export * from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tabset.component";
export * from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tabset.component.a11y";
export * from "./widgetfideuram/components/nbp-fid-toggle-tabset/nbp-fid-toggle-tabset.component.noa11y";
export * from "./widgetfideuram/components/showcase/showcase.component";
export * from "./widgetfideuram/components/showcase/showcase1.component";
export * from "./widgetfideuram/components/widget-fideuram-showcase/widget-fideuram-showcase.component";

export * from "./widgetfideuram/Utils";

@NgModule({
  imports: [XdceArchModule, NbpModule, AgGridModule, FormsModule, NgbModule],
  declarations: [
    NbpBreadCrumbsComponent,
    NbpFidBarChartComponent,
    NbpFidButtonBarComponent,
    NbpFidComboComponent,
    NbpFidDonutChartComponent,
    NbpFidPyramidChartComponent,
    NbpFidSidePopupComponent,
    NbpFidTableComponent,
    NbpFidToggleTabComponentA11Y,
    NbpFidToggleTabComponentNOA11Y,
    NbpFidToggleTabComponent,
    NbpFidToggleTabsetComponentA11Y,
    NbpFidToggleTabsetComponentNOA11Y,
    NbpFidToggleTabsetComponent,
    ShowcaseComponent,
    Showcase1Component,
    WidgetFideuramShowcaseComponent,
    NbpFidCalendarGeneric,
    NgbFidInputDatepicker,
    FidRplCalendarNOA11Y,
    NbpCalendarGenericComponentNOA11Y,
    NbpCalendarGenericComponentA11Y,
    FidRplCalendar,
    NgbFidInputDatepickerNOA11Y,
    NgbFidDatepickerRoutingView,
    NgbFidDatepickerRoutingViewNOA11Y
  ],
  exports: [
    NbpBreadCrumbsComponent,
    NbpFidBarChartComponent,
    NbpFidButtonBarComponent,
    NbpFidComboComponent,
    NbpFidDonutChartComponent,
    NbpFidPyramidChartComponent,
    NbpFidSidePopupComponent,
    NbpFidTableComponent,
    NbpFidToggleTabComponentA11Y,
    NbpFidToggleTabComponentNOA11Y,
    NbpFidToggleTabComponent,
    NbpFidToggleTabsetComponentA11Y,
    NbpFidToggleTabsetComponentNOA11Y,
    NbpFidToggleTabsetComponent,
    ShowcaseComponent,
    Showcase1Component,
    WidgetFideuramShowcaseComponent,
    AgGridModule,
    NbpFidCalendarGeneric,
    FidRplCalendarNOA11Y,
    FidRplCalendar,
    NgbFidDatepickerRoutingView,
    NgbFidDatepickerRoutingViewNOA11Y,
    NgbFidInputDatepickerNOA11Y,
    NgbFidInputDatepicker
  ],
  providers: [
    AngularFrameworkOverrides, 
    AngularFrameworkComponentWrapper,
    { provide: 'NgbDatepickerServiceNOA11Y', useClass: NgbDatepickerServiceNOA11Y },
    { provide: 'NgbDatepickerService', useClass: NgbDatepickerService }
  ],
  entryComponents: [
    NbpFidToggleTabComponentA11Y,
    NbpFidToggleTabComponentNOA11Y,
    NbpFidToggleTabsetComponentA11Y,
    NbpFidToggleTabsetComponentNOA11Y,
    NbpFidToggleTabComponent,
    NbpFidToggleTabsetComponent,
    NbpCalendarGenericComponentA11Y,
    NbpCalendarGenericComponentNOA11Y,
    FidRplCalendarNOA11Y,
    FidRplCalendar,
    NgbFidDatepickerRoutingView,
    NgbFidDatepickerRoutingViewNOA11Y
  ],
  schemas: [NO_ERRORS_SCHEMA]
})
export class XdceWidgetFideuramModule {
  static forRoot(): ModuleWithProviders {
    return {
      ngModule: XdceWidgetFideuramModule,
      providers: [],
    };
  }
}
