import { Component, Input, HostBinding, Injector, TemplateRef, ElementRef } from '@angular/core';
import { NbpBaseComponent } from '@isp/xdce-widget/base'

@Component({
  template: '<ng-container *ngIf="active"><ng-container *ngTemplateOutlet="wngContent"></ng-container></ng-container>',
  styleUrls: ['./nbp-fid-tab-toggle.component.a11y.scss']
})
export class NbpFidToggleTabComponentA11Y extends NbpBaseComponent {

  protected isA11Y = true;

  wngContent: TemplateRef<any>;

  @Input() tabTemplate: TemplateRef<any> = null;

  /**
   * Titolo del tab
   */
  @Input() title = '';

  /**
   * Booleano che indica se il tab è selezionato inizialmente
   */
  @Input() active = false;

  /**
   * Booleano che indica se il tab è disabilitato
   */
  @Input() disabled = false;

  /**
   * Id del componente
   */
  private _id: string = undefined;
  @Input()
  set id(value: string) {
    this._id = value;
    this.er.nativeElement.id = value;
  }
  get id(): string {
      return this._id;
  }


  constructor(injector : Injector) {
    super(injector);
  }
}
